#include<MT/truncatedGaussian.h>
#include<MT/plot.h>
#include<MT/util.h>

void testTruncGauss(){
  uint N=MT::getParameter<uint>("dim",2);
  //random covariance and mean
  arr A,M(N,N),a(N),c(N);
  rndUni(M,.1,1.);
  A=~M*M;
  rndUni(a,.1,1.);

  //random constraint
  double coff=rnd.uni(-1.,1.);
  rndUni(c,.1,1.);
  //c(0)=-4.; c(1)=2.; //c(2)=1.;
  c /= norm(c);

  //plot problem
  plotCovariance(a,A);
  arr line(2,2);
  line(0,0)=-coff*c(0);     line(0,1)=-coff*c(1);
  line(1,0)=line(0,0)+c(0); line(1,1)=line(0,1)+c(1);
  plotLine(line);

  //analytical solution
  arr b,B;
  b=a; B=A;
  TruncateGaussian(b,B,c,coff);
  plotCovariance(b,B);

  //sampling solution
  b=a; B=A;
  arr data;
  TruncateGaussianBySampling(b,B,c,coff,MT::getParameter<uint>("samples",1000),&data);
  plotPoints(data);
  plotCovariance(b,B);
  plot(false);
}

int main(int argc, char *argv[]){
  cout <<"USAGE: ./x.exe -seed <integer> -dim <integer> -samples <integer>\n" <<endl;
  
  MT::initCmdLine(argc,argv);
  
  testTruncGauss();
  
  return 0;
}

